Name: gambit-bh-std
Version: 20090817
Release: alt3
Summary: General purpose libraries for BH Gambit-C Scheme module system
License: MIT+
Group: Development/Scheme
URL: git://github.com/pereckerdal/blackhole-libs.git

Packager: Paul Wolneykien <manowar@altlinux.ru>

BuildPreReq: gambit-bh

Source: %name-%version.tar.gz

%description
Black Hole (BH) is a module system abstraction for Gambit-C Scheme
programming system providing recurring module file dependency compilation
and loading, including export of macros, for regular R5RS Scheme.

This package contains a set of general purpose libraries for BH.

%package ds
Summary: Data structure libraries for BH Gambit-C Scheme module system
License: MIT+
Group: Development/Scheme
Requires: %name = %version-%release
Requires: gambit-bh

Provides: gambit-bh(std.ds/queue)
Provides: gambit-bh(std.ds/wt-tree)

%description ds
Black Hole (BH) is a module system abstraction for Gambit-C Scheme
programming system providing recurring module file dependency compilation
and loading, including export of macros, for regular R5RS Scheme.

This package contains data structure libraries for BH Gambit-C Scheme
module system:

  * FIFO queue;
  * Weight balanced trees.

%package misc
Summary: Miscellaneous libraries for BH Gambit-C Scheme module system
License: MIT+
Group: Development/Scheme
Requires: %name = %version-%release
Requires: gambit-bh
Requires: gambit-bh(module)

Provides: gambit-bh(std.misc/al)
Provides: gambit-bh(std.misc/exception)
Provides: gambit-bh(std.misc/mailbox)
Provides: gambit-bh(std.misc/match)
Provides: gambit-bh(std.misc/optionals)
Provides: gambit-bh(std.misc/splice)
Provides: gambit-bh(std.misc/token-table)
Provides: gambit-bh(std.misc/u8v)
Provides: gambit-bh(std.misc/uuid)

%description misc
Black Hole (BH) is a module system abstraction for Gambit-C Scheme
programming system providing recurring module file dependency compilation
and loading, including export of macros, for regular R5RS Scheme.

This package contains miscellaneous libraries for BH Gambit-C Scheme
module system:

  * A-list helper library;
  * Exception handling helper library;
  * Single-element mailbox library;
  * Erlang-style list matcher;
  * (let-optionals) special form support;
  * Splicer;
  * Token tables;
  * U8vector utility functions;
  * UUID generator.

%package net
Summary: Network-related libraries for BH Gambit-C Scheme module system
License: MIT+
Group: Development/Scheme
Requires: %name = %version-%release
Requires: gambit-bh
Requires: gambit-bh(std.ds/queue)
Requires: gambit-bh(std.ds/wt-tree)
Requires: gambit-bh(std.string/base64)
Requires: gambit-bh(std.string/util)
Requires: gambit-bh(std.string/sxml-to-xml)
Requires: gambit-bh(std.srfi/1)
Requires: gambit-bh(std.srfi/13)
Requires: gambit-bh(std.srfi/19)
Requires: gambit-bh(std.misc/al)
Requires: gambit-bh(std.misc/token-table)
Requires: gambit-bh(std.misc/uuid)

Provides: gambit-bh(std.net/http-client)
Provides: gambit-bh(std.net/http-common)
Provides: gambit-bh(std.net/http-server)
Provides: gambit-bh(std.net/http-session)
Provides: gambit-bh(std.net/tcpip)
Provides: gambit-bh(std.net/uri)
Provides: gambit-bh(std.net/x-www-form-urlencoded)

%description net
Black Hole (BH) is a module system abstraction for Gambit-C Scheme
programming system providing recurring module file dependency compilation
and loading, including export of macros, for regular R5RS Scheme.

This package contains network-related libraries for BH Gambit-C Scheme
module system:

  * HTTP client;
  * Common HTTP features;
  * HTTP server;
  * HTTP session helper library;
  * TCP/IP helper procedures;
  * URI handling;
  * x-www-form-urlencoded encoding and decoding.

%package srfi
Summary: Some SRFI libraries for BH Gambit-C Scheme module system
License: MIT+
Group: Development/Scheme
Requires: %name = %version-%release
Requires: gambit-bh
Requires: gambit-bh(std.misc/optionals)

Provides: gambit-bh(std.srfi/13)
Provides: gambit-bh(std.srfi/14)
Provides: gambit-bh(std.srfi/16)
Provides: gambit-bh(std.srfi/19)
Provides: gambit-bh(std.srfi/1)
Provides: gambit-bh(std.srfi/95)

%description srfi
Black Hole (BH) is a module system abstraction for Gambit-C Scheme
programming system providing recurring module file dependency compilation
and loading, including export of macros, for regular R5RS Scheme.

This package contains some SRFI libraries for BH Gambit-C Scheme
module system:

  * SRFI 1 -- List processing;
  * SRFI 13 -- String;
  * SRFI 14 -- Character-sets;
  * SRFI 16 -- (case-lambda) special form support;
  * SRFI 19 -- Time data types and procedures;
  * SRFI 95 -- Sorting.

%package text
Summary: Text processing libraries for BH Gambit-C Scheme module system
License: MIT+
Group: Development/Scheme
Requires: %name = %version-%release
Requires: gambit-bh
Requires: gambit-bh(std.srfi/1)
Requires: gambit-bh(std.srfi/13)
Requires: gambit-bh(std.misc/u8v)

Provides: gambit-bh(std.string/base64)
Provides: gambit-bh(std.string/digest)
Provides: gambit-bh(std.string/pregexp)
Provides: gambit-bh(std.string/sxml-to-xml)
Provides: gambit-bh(std.string/util)
Provides: gambit-bh(std.string/xml-to-sxml)

%description text
Black Hole (BH) is a module system abstraction for Gambit-C Scheme
programming system providing recurring module file dependency compilation
and loading, including export of macros, for regular R5RS Scheme.

This package contains text processing libraries for BH Gambit-C Scheme
module system:

  * Base64 processing library;
  * Hash computation library;
  * Posix Regular Expressions matching engine library;
  * Fast SXML to XML generator;
  * String utility procedures;
  * Fast XML string to SXML parser.

%prep
%setup -q

%build
gsc -e '(prepend-module-dirs! "./")' -e '(modules-compile! (modules-in-dir "ds") #t)'
gsc -e '(prepend-module-dirs! "./")' -e '(modules-compile! (modules-in-dir "misc") #t)'
gsc -e '(prepend-module-dirs! "./")' -e '(modules-compile! (modules-in-dir "net") #t)'
gsc -e '(prepend-module-dirs! "./")' -e '(modules-compile! (modules-in-dir "srfi") #t)'
gsc -e '(prepend-module-dirs! "./")' -e '(modules-compile! (modules-in-dir "string") #t)'

%install
install -d -m0755 %buildroot%{_libdir}/blackhole/std/ds
install -p -m0644 ds/*.scm %buildroot%{_libdir}/blackhole/std/ds/
install -p -m0644 ds/*.o1 %buildroot%{_libdir}/blackhole/std/ds/
install -d -m0755 %buildroot%{_libdir}/blackhole/std/misc
install -p -m0644 misc/*.scm %buildroot%{_libdir}/blackhole/std/misc/
install -p -m0644 misc/*.o1 %buildroot%{_libdir}/blackhole/std/misc/
install -d -m0755 %buildroot%{_libdir}/blackhole/std/net
install -p -m0644 net/*.scm %buildroot%{_libdir}/blackhole/std/net/
install -p -m0644 net/*.o1 %buildroot%{_libdir}/blackhole/std/net/
install -d -m0755 %buildroot%{_libdir}/blackhole/std/srfi
install -p -m0644 srfi/*.scm %buildroot%{_libdir}/blackhole/std/srfi/
install -p -m0644 srfi/*.o1 %buildroot%{_libdir}/blackhole/std/srfi/
install -d -m0755 %buildroot%{_libdir}/blackhole/std/string
install -p -m0644 string/*.scm %buildroot%{_libdir}/blackhole/std/string/
install -p -m0644 string/*.o1 %buildroot%{_libdir}/blackhole/std/string/

%post ds
touch %{_libdir}/blackhole/std/ds/*.o1

%post misc
touch %{_libdir}/blackhole/std/misc/*.o1

%post net
touch %{_libdir}/blackhole/std/net/*.o1

%post srfi
touch %{_libdir}/blackhole/std/srfi/*.o1

%post text
touch %{_libdir}/blackhole/std/string/*.o1

%files
%doc Black_Hole_Bundled_libraries.pdf README LICENSE
%dir %{_libdir}/blackhole/std

%files ds
%{_libdir}/blackhole/std/ds

%files misc
%{_libdir}/blackhole/std/misc

%files net
%{_libdir}/blackhole/std/net

%files srfi
%{_libdir}/blackhole/std/srfi

%files text
%{_libdir}/blackhole/std/string

%changelog
* Wed Sep 09 2009 Paul Wolneykien <manowar@altlinux.ru> 20090817-alt3
- Preserve timestamps of the source files.

* Wed Sep 09 2009 Paul Wolneykien <manowar@altlinux.ru> 20090817-alt2
- Requires: %name = %version-%release.

* Tue Sep 08 2009 Paul Wolneykien <manowar@altlinux.ru> 20090817-alt1
- Initial build for ALTLinux.
